#ifndef MSGSERVER_HH
#define MSGSERVER_HH

#include <map>

#include <iserver.hh>
#include <message.hh>
#include <msgConstants.hh>

class msgServer {

	private:
		iserver iserv;
		bool isRunning;
		bool isMessagesWaiting;
		unsigned long int inactivityTime;
		std::map<int, std::string> clients;
		
		typedef std::map<int, std::string> clientList;
		clientList::iterator find(const clientList::iterator& begin, const clientList::iterator& end, const std::string& name){
			clientList::iterator it=begin;
			while(it!=end){
				if(it->second==name){
					return it;
				}
			}
			return it;
		}
		
	public:
		msgServer(const std::string& address = DEFAULT_SERVER_ADDRESS, const std::string& port=DEFAULT_SERVER_PORT, bool toggleTime=true, unsigned long int inact=DEFAULT_SERVER_INACTIVITY_TIME, size_t maxConnections=MAX_CLIENT_CONNECTIONS);
		~msgServer();
		void run();
		void addConnection(int c, std::string n);
		void removeConnection(int c);
//		void setInactivityTime(unsigned int inact);
		bool isConnected(std::string c);
		void manageIncomingMessage(int c, message m);
		void sendTo(std::string dest, std::string m);
		void shutdown();
		
};

#endif
